DEFINT A-Z
DECLARE SUB text (yy%, xx%, ss$, sp%)
DECLARE SUB graphicput (yy1%, xx1%, ss1$)
DECLARE SUB suspend (start!, delay)
DECLARE SUB MouseDriver (AX%, bx%, CX%, dx%)
DECLARE FUNCTION MouseInit% ()
DECLARE SUB mouseshow ()
DECLARE SUB mousestatus (lb%, rb%, Xmouse%, Ymouse%)
DECLARE SUB cursorput ()
DECLARE SUB cinput ()
DECLARE SUB plot (xx, yy, zz, cc, tt$, pp)
DECLARE SUB triangle (triax, triay, tribx, triby, tricx, tricy, tricc)
DECLARE SUB threetotwo (thtwx, thtwy, thtwz)

COMMON SHARED c$

COMMON SHARED MouseB%
COMMON SHARED MouseLLast%
COMMON SHARED MouseRLast%
COMMON SHARED MouseXLast%
COMMON SHARED MouseYLast%
COMMON SHARED MouseZLast%
COMMON SHARED MouseLCurrent%
COMMON SHARED MouseRCurrent%
COMMON SHARED MouseXCurrent%
COMMON SHARED MouseYCurrent%
COMMON SHARED MouseZCurrent%

COMMON SHARED MouseLBStart%
COMMON SHARED MouseLXStart%
COMMON SHARED MouseLYStart%
COMMON SHARED MouseLZStart%
COMMON SHARED MouseLBEnd%
COMMON SHARED MouseLXEnd%
COMMON SHARED MouseLYEnd%
COMMON SHARED MouseLZEnd%

COMMON SHARED MouseRBStart%
COMMON SHARED MouseRXStart%
COMMON SHARED MouseRYStart%
COMMON SHARED MouseRZStart%
COMMON SHARED MouseRBEnd%
COMMON SHARED MouseRXEnd%
COMMON SHARED MouseRYEnd%
COMMON SHARED MouseRZEnd%

COMMON SHARED spin AS DOUBLE
COMMON SHARED tip AS DOUBLE
COMMON SHARED size AS DOUBLE

COMMON SHARED PtX AS DOUBLE
COMMON SHARED PtY AS DOUBLE
COMMON SHARED PtZ AS DOUBLE

COMMON SHARED xx AS DOUBLE
COMMON SHARED yy AS DOUBLE
COMMON SHARED zz AS DOUBLE

COMMON SHARED renx
COMMON SHARED reny
COMMON SHARED renz

COMMON SHARED renax
COMMON SHARED renay
COMMON SHARED renaz

COMMON SHARED renbx
COMMON SHARED renby
COMMON SHARED renbz

COMMON SHARED rencx
COMMON SHARED rency
COMMON SHARED rencz

DIM SHARED triv(1 TO 3, 1 TO 2)

DIM SHARED mouse$

DIM SHARED t(0 TO 31 * 32)

DIM SHARED axis(0 TO 3, 0 TO 3) AS DOUBLE

CONST pi = 3.141592654#

MouseB% = -1

RANDOMIZE TIMER
RESTORE
mouse$ = SPACE$(57)
FOR I% = 1 TO 57
  READ a$
  H$ = CHR$(VAL("&H" + a$))
  MID$(mouse$, I%, 1) = H$
NEXT I%
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00
MS% = MouseInit%
IF NOT MS% THEN
  REM''PRINT "Mouse not found"
  AMOUSE$ = "NO"
  MouseB% = 0
END IF
IF MS% THEN
  REM''PRINT "Mouse found and initialized"
  AMOUSE$ = "YES"
  MouseB% = -1
  REM''mouseshow
END IF

PtTotal = 0
FOR t = 0 TO PtTotal
  pt(t, 1) = 32
  pt(t, 2) = 8
  pt(t, 3) = 0
  pt(t, 4) = 32
  pt(t, 5) = 8
  pt(t, 6) = 0
  pt(t, 7) = t
  pt(t, 8) = t
  pt(t, 9) = t
  pt(t, 10) = t
NEXT t

spin = 0 / 32
tip = 0 / 32
size = 32 / 32

SCREEN 7, 0, 0, 0
cinput

RANDOMIZE TIMER
RESTORE
SCREEN 7, 0, 1, 0
LINE (0, 0)-(319, 199), 0, BF
10 :

LINE (0, 0)-(319, 199), 0, BF
cinput

'spin = spin + (1 / 32)
'IF spin > 1 THEN spin = spin - 1
IF c$ = "*" THEN
  spin = spin + (1 / 32)
  IF spin > 1 THEN spin = spin - 1
END IF
IF c$ = "/" THEN
  spin = spin - (1 / 32)
  IF spin < 0 THEN spin = 1 + spin
END IF
IF c$ = "a" THEN
  tip = tip + (1 / 32)
  IF tip > 1 THEN tip = tip - 1
END IF
IF c$ = "z" THEN
  tip = tip - (1 / 32)
  IF tip < 0 THEN tip = 1 + tip
END IF

LOCATE 1, 1: PRINT "x:"; MouseXCurrent%;
LOCATE 2, 1: PRINT "y:"; MouseYCurrent%;
LOCATE 3, 1: PRINT "z:"; MouseZCurrent%;

LOCATE 5, 1: PRINT "spin:"; spin;
LOCATE 6, 1: PRINT "tip :"; tip;
LOCATE 7, 1: PRINT "size:"; size;

axis(1, 1) = COS(2 * pi * spin)
axis(1, 2) = -SIN(2 * pi * spin)
axis(1, 3) = 0
axis(2, 1) = -SIN(2 * pi * tip) * SIN(2 * pi * spin)
axis(2, 2) = -SIN(2 * pi * tip) * COS(2 * pi * spin)
axis(2, 3) = COS(2 * pi * tip)
axis(3, 1) = COS(2 * pi * tip) * SIN(2 * pi * spin)
axis(3, 2) = COS(2 * pi * tip) * COS(2 * pi * spin)
axis(3, 3) = SIN(2 * pi * tip)

M0Dis = 0: M0DisT = 0
L1Dis = 0: L1DisT = 0
L2Dis = 0: L2DisT = 0
R1Dis = 0: R1DisT = 0
R2Dis = 0: R2DisT = 0

IF (MouseLBStart% <> 0) AND (MouseLBEnd% <> 0) AND (MouseLXStart% < 16) THEN
  MouseLBStart% = 0
  MouseLXStart% = 0
  MouseLYStart% = 0
  MouseLZStart% = 0
  MouseLBEnd% = 0
  MouseLXEnd% = 0
  MouseLYEnd% = 0
  MouseLZEnd% = 0
END IF
 
  IF (MouseLBStart% <> 0) AND (MouseLBEnd% = 0) THEN
    plot MouseLXStart%, MouseLYStart%, MouseLZStart%, 5, "point", 0
    plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent%, 5, "line", INT(RND(1) * 2 ^ 14!)
  END IF
  IF (MouseLBStart% <> 0) AND (MouseLBEnd% <> 0) THEN
    plot MouseLXStart%, MouseLYStart%, MouseLZStart%, 5, "point", 0
    plot MouseLXEnd%, MouseLYEnd%, MouseLZEnd%, 5, "line", INT(RND(1) * 2 ^ 14!)
  END IF
  IF (MouseRBStart% <> 0) AND (MouseRBEnd% = 0) THEN
    plot MouseRXStart%, MouseRYStart%, MouseRZStart%, 5, "point", 0
    plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent%, 5, "line", INT(RND(1) * 2 ^ 14!)
  END IF
  IF (MouseRBStart% <> 0) AND (MouseRBEnd% <> 0) THEN
    plot MouseRXStart%, MouseRYStart%, MouseRZStart%, 5, "point", 0
    plot MouseRXEnd%, MouseRYEnd%, MouseRZEnd%, 5, "line", INT(RND(1) * 2 ^ 14!)
  END IF

IF (MouseRBStart% <> 0) AND (MouseRBEnd% = 0) AND (MouseLBStart% <> 0) AND (MouseLBEnd% = 0) THEN
 plot MouseLXStart%, MouseLYStart%, MouseLZStart%, 5, "point", 0
 plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent%, 5, "line", INT(RND(1) * 2 ^ 14!)
 plot MouseRXStart%, MouseRYStart%, MouseRZStart%, 5, "point", 0
 plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent%, 5, "line", INT(RND(1) * 2 ^ 14!)
 plot MouseLXStart%, MouseLYStart%, MouseLZStart%, 5, "point", 0
 plot MouseRXStart%, MouseRYStart%, MouseRZStart%, 5, "line", INT(RND(1) * 2 ^ 14!)

 renax = MouseLXStart%
 renay = MouseLYStart%
 renaz = MouseLZStart%
 threetotwo renax, renay, renaz
 renax = renx
 renay = reny
 renaz = renz

 renbx = MouseRXStart%
 renby = MouseRYStart%
 renbz = MouseRZStart%
 threetotwo renbx, renby, renbz
 renbx = renx
 renby = reny
 renbz = renz

 rencx = MouseXCurrent%
 rency = MouseYCurrent%
 rencz = MouseZCurrent%
 threetotwo rencx, rency, rencz
 rencx = renx
 rency = reny
 rencz = renz

 triangle renax, renaz, renbx, renbz, rencx, rencz, 10
END IF

plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent%, 13, "point", 0
plot MouseXCurrent% - 5, MouseYCurrent%, MouseZCurrent%, 13, "point", 0
plot MouseXCurrent% + 5, MouseYCurrent%, MouseZCurrent%, 13, "line", 0
plot MouseXCurrent%, MouseYCurrent% - 5, MouseZCurrent%, 13, "point", 0
plot MouseXCurrent%, MouseYCurrent% + 5, MouseZCurrent%, 13, "line", 0
plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent% - 5, 13, "point", 0
plot MouseXCurrent%, MouseYCurrent%, MouseZCurrent% + 5, 13, "line", 0

PCOPY 1, 0
IF c$ = CHR$(27) THEN
  END
END IF
GOTO 10

okbutton:
  text 23, 25, "Ok", 0
wwait:
  GOSUB buttonwait
  IF ((c$ = "O" OR c$ = CHR$(13) OR c$ = "o") OR (INT(Ymouse% / 8) + 1 = 23 AND INT(Xmouse% / 8) + 1 = 25 AND lb% = -1)) THEN
    c$ = "L"
    ELSE
    GOTO wwait
  END IF
RETURN

buttonwait:
  PCOPY 1, 3
  cinput
  cursorput
  PCOPY 1, 0
  PCOPY 3, 1
RETURN

SUB cinput
MouseLLast% = MouseLCurrent%
MouseRLast% = MouseRCurrent%
MouseXLast% = MouseXCurrent%
MouseYLast% = MouseYCurrent%
MouseZLast% = MouseZCurrent%
c$ = INKEY$
IF (c$ = "") THEN c$ = CHR$(0)
IF (MouseB% = 0) THEN
  IF c$ = "h" THEN MouseXCurrent% = MouseXCurrent% + 8
  IF c$ = "g" THEN MouseXCurrent% = MouseXCurrent% - 8
  IF c$ = "b" THEN MouseYCurrent% = MouseYCurrent% + 8
  IF c$ = "y" THEN MouseYCurrent% = MouseYCurrent% - 8
  IF c$ = "+" THEN MouseZCurrent% = MouseZCurrent% + 8
  IF c$ = "-" THEN MouseZCurrent% = MouseZCurrent% - 8
END IF
IF (MouseB% <> 0) THEN
  mousestatus lb%, rb%, Xmouse%, Ymouse%
  MouseLCurrent% = lb%
  MouseRCurrent% = rb%
  MouseXCurrent% = 8 * CINT(Xmouse% / 8)
  MouseYCurrent% = 8 * CINT(Ymouse% / 8)
  MouseZCurrent% = MouseZCurrent%
  IF c$ = "+" THEN MouseZCurrent% = MouseZCurrent% + 8
  IF c$ = "-" THEN MouseZCurrent% = MouseZCurrent% - 8
  IF (MouseLLast% = 0) AND (MouseLCurrent% <> 0) THEN
    MouseLBStart% = MouseLCurrent%
    MouseLXStart% = MouseXCurrent%
    MouseLYStart% = MouseYCurrent%
    MouseLZStart% = MouseZCurrent%
    MouseLBEnd% = 0
    MouseLXEnd% = 0
    MouseLYEnd% = 0
    MouseLZEnd% = 0
  END IF
  IF (MouseLLast% <> 0) AND (MouseLCurrent% = 0) AND (MouseLBStart% <> 0) AND (MouseLBEnd% = 0) THEN
    MouseLBEnd% = MouseLLast%
    MouseLXEnd% = MouseXLast%
    MouseLYEnd% = MouseYLast%
    MouseLZEnd% = MouseZLast%
  END IF
  IF (MouseRLast% = 0) AND (MouseRCurrent% <> 0) THEN
    MouseRBStart% = MouseRCurrent%
    MouseRXStart% = MouseXCurrent%
    MouseRYStart% = MouseYCurrent%
    MouseRZStart% = MouseZCurrent%
    MouseRBEnd% = 0
    MouseRXEnd% = 0
    MouseRYEnd% = 0
    MouseRZEnd% = 0
  END IF
  IF (MouseRLast% <> 0) AND (MouseRCurrent% = 0) AND (MouseRBStart% <> 0) AND (MouseRBEnd% = 0) THEN
    MouseRBEnd% = MouseRLast%
    MouseRXEnd% = MouseXLast%
    MouseRYEnd% = MouseYLast%
    MouseRZEnd% = MouseZLast%
  END IF
END IF
END SUB

SUB cursorput
  LINE (MouseXCurrent% - 2, MouseYCurrent% - 2)-(MouseXCurrent% + 2, MouseYCurrent% + 2), 9
  LINE (MouseXCurrent% + 2, MouseYCurrent% - 2)-(MouseXCurrent% - 2, MouseYCurrent% + 2), 9
END SUB

SUB graphicput (yy1%, xx1%, ss1$)
REM''IF ABS(yy1% - dy) <= 2 AND ABS(xx1% - ex) <= 2 THEN
  IF LEN(ss1$) > 4 THEN
     IF RIGHT$(ss1$, 4) = ".trn" THEN
      DEF SEG = VARSEG(t(0))
      BLOAD ss1$, VARPTR(t(0))
      PUT ((xx1% - 1) * 8, (yy1% - 1) * 8), t(0), PSET
    END IF
    IF RIGHT$(ss1$, 4) = ".sil" THEN
      DEF SEG = VARSEG(t(0))
      BLOAD ss1$, VARPTR(t(0))
      PUT ((xx1% - 1) * 8, (yy1% - 1) * 8), t(0), AND
    END IF
    IF RIGHT$(ss1$, 4) = ".24x" THEN
      DEF SEG = VARSEG(t(0))
      BLOAD ss1$, VARPTR(t(0))
      PUT ((xx1% - 1) * 8, (yy1% - 1) * 8), t(0), OR
    END IF
  END IF
  IF LEN(ss1$) <= 4 THEN
    REM'LOCATE yy1% + 1, xx1% + 1: PRINT ".";
  END IF
REM''END IF
END SUB

DEFSNG A-Z
SUB MouseDriver (AX%, bx%, CX%, dx%)
  DEF SEG = VARSEG(mouse$)
  mouse% = SADD(mouse$)
  CALL Absolute(AX%, bx%, CX%, dx%, mouse%)
END SUB

SUB MouseHide
 AX% = 2
 MouseDriver AX%, 0, 0, 0
END SUB

FUNCTION MouseInit%
  AX% = 0
  MouseDriver AX%, 0, 0, 0
  MouseInit% = AX%
END FUNCTION

SUB mouseput
  AX% = 4
  CX% = x%
  dx% = y%
  MouseDriver AX%, 0, CX%, dx%
END SUB

SUB mouseshow
  AX% = 1
  MouseDriver AX%, 0, 0, 0
END SUB

SUB mousestatus (lb%, rb%, Xmouse%, Ymouse%)
  AX% = 3
  MouseDriver AX%, bx%, CX%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
  Xmouse% = CX% * .5
  Ymouse% = dx%
END SUB

DEFINT A-Z
SUB plot (xx, yy, zz, cc, tt$, pp)
xxx = xx
yyy = yy
zzz = zz
IF xxx > -16000 THEN xxx = xxx - 159
IF yyx > -16000 THEN yyy = yyy - 99
IF zzx > -16000 THEN zzz = zzz
PtX = xxx * axis(1, 1) + yyy * axis(1, 2) + zzz * axis(1, 3)
PtY = xxx * axis(2, 1) + yyy * axis(2, 2) + zzz * axis(2, 3)
PtZ = xxx * axis(3, 1) + yyy * axis(3, 2) + zzz * axis(3, 3)
IF tt$ = "point" THEN
  PSET (159 + size * PtX, 99 + size * PtZ), cc
END IF
IF tt$ = "line" THEN
  IF pp = 0 THEN
    LINE -(159 + size * PtX, 99 + size * PtZ), cc
  ELSE
    LINE -(159 + size * PtX, 99 + size * PtZ), cc, , pp
  END IF
END IF
IF tt$ = "space" THEN
  FOR yyy = (yy - 99) - 4 TO (yy - 99 + 4) STEP 2
    FOR xxx = (xx - 159 - 4) TO (xx - 159 + 4) STEP 2
      zzz = zz
      PtX = xxx * axis(1, 1) + yyy * axis(1, 2) + zzz * axis(1, 3)
      PtY = xxx * axis(2, 1) + yyy * axis(2, 2) + zzz * axis(2, 3)
      PtZ = xxx * axis(3, 1) + yyy * axis(3, 2) + zzz * axis(3, 3)
      PSET (159 + size * PtX, 99 + size * PtZ), cc
    NEXT xxx
  NEXT yyy
END IF
END SUB

SUB suspend (start!, delay)
  PCOPY 1, 3
  cinput
  cursorput
  PCOPY 1, 0
  PCOPY 3, 1
  DO
    REM' commands to do while suspended
    cinput
    cursorput
    PCOPY 1, 0
    PCOPY 3, 1
  LOOP UNTIL (TIMER < start!) OR (TIMER >= start! + delay): REM'check before ending loop
END SUB

SUB text (yy%, xx%, ss$, sp%)
REM'FOR ttt = 1 TO LEN(ss$)
REM'  ss% = ASC(MID$(ss$, ttt, 1))
REM'  IF ss% >= 33 AND ss% <= 255 THEN
REM'    REM'sss$ = RIGHT$(STR$(1000 + ss%), 3) + "_mask.CHR"
REM'    REM'DEF SEG = VARSEG(t(0))
REM'    REM'BLOAD sss$, VARPTR(t(0))
REM'    REM'PUT ((xx% + ttt - 2) * 8, (yy% - 1) * 8), t(0), AND
REM'    REM'sss$ = RIGHT$(STR$(1000 + ss%), 3) + "_tile.CHR"
REM'    REM'DEF SEG = VARSEG(t(0))
REM'    REM'BLOAD sss$, VARPTR(t(0))
REM'    REM'PUT ((xx% + ttt - 2) * 8, (yy% - 1) * 8), t(0), OR
REM'    LOCATE yy%, xx% + ttt - 1
REM'    PRINT CHR$(ss%);
REM'  END IF
REM'  st! = TIMER
REM'  suspend st!, sp%
REM'    PCOPY 1, 0
REM'NEXT ttt
LOCATE yy%, xx%
PRINT ss$;
END SUB

SUB threetotwo (thtwx, thtwy, thtwz)

xxx = thtwx
yyy = thtwy
zzz = thtwz
IF xxx > -16000 THEN xxx = xxx - 319
IF yyx > -16000 THEN yyy = yyy - 174
IF zzx > -16000 THEN zzz = zzz
PtX = xxx * axis(1, 1) + yyy * axis(1, 2) + zzz * axis(1, 3)
PtY = xxx * axis(2, 1) + yyy * axis(2, 2) + zzz * axis(2, 3)
PtZ = xxx * axis(3, 1) + yyy * axis(3, 2) + zzz * axis(3, 3)
renx = PtX
reny = PtY
renz = PtZ

END SUB

SUB triangle (triax, triay, tribx, triby, tricx, tricy, tricc)

triv(1, 1) = triax
triv(1, 2) = triay
triv(2, 1) = tribx
triv(2, 2) = triby
triv(3, 1) = tricx
triv(3, 2) = tricy

FOR triv = 1 TO 3
 triv1 = triv
 triv2 = (triv1 MOD 3) + 1
 triv3 = (triv2 MOD 3) + 1
 IF triv(triv1, 2) <= triv(triv2, 2) AND triv(triv1, 2) <= triv(triv3, 2) THEN
  IF triv(triv2, 2) > triv(triv3, 2) THEN SWAP triv2, triv3

  IF triv(triv2, 2) > triv(triv1, 2) THEN
   trivx1 = triv(triv2, 2) - triv(triv1, 2)
   trivy1 = triv(triv2, 1) - triv(triv1, 1)
   trivx2 = triv(triv3, 2) - triv(triv1, 2)
   trivy2 = triv(triv3, 1) - triv(triv1, 1)
   FOR triy = triv(triv1, 2) TO triv(triv2, 2) STEP 2
    trix1 = trivy1 / trivx1 * (triy - triv(triv1, 2)) + triv(triv1, 1)
    trix2 = trivy2 / trivx2 * (triy - triv(triv1, 2)) + triv(triv1, 1)
    LINE (319 + size * trix1, 174 + size * triy)-(319 + size * trix2, 174 + size * triy), tricc, , 2 ^ 0 + 2 ^ 2 + 2 ^ 4 + 2 ^ 6 + 2 ^ 8 + 2 ^ 10 + 2 ^ 12 + 2 ^ 14
    'IF trix1 > trix2 THEN SWAP trix1, trix2
    'FOR trix = trix1 TO trix2 STEP 1
    ' PSET (trix, triy), tricc
    'NEXT trix
   NEXT triy
  END IF

  IF triv(triv3, 2) > triv(triv2, 2) THEN
   trivx1 = triv(triv2, 2) - triv(triv3, 2)
   trivy1 = triv(triv2, 1) - triv(triv3, 1)
   trivx2 = triv(triv3, 2) - triv(triv1, 2)
   trivy2 = triv(triv3, 1) - triv(triv1, 1)
   FOR triy = triv(triv2, 2) TO triv(triv3, 2) STEP 2
    trix1 = trivy1 / trivx1 * (triy - triv(triv2, 2)) + triv(triv2, 1)
    trix2 = trivy2 / trivx2 * (triy - triv(triv1, 2)) + triv(triv1, 1)
    LINE (319 + size * trix1, 174 + size * triy)-(319 + size * trix2, 174 + size * triy), tricc, , 2 ^ 0 + 2 ^ 2 + 2 ^ 4 + 2 ^ 6 + 2 ^ 8 + 2 ^ 10 + 2 ^ 12 + 2 ^ 14
    'IF trix1 > trix2 THEN SWAP trix1, trix2
    'FOR trix = trix1 TO trix2 STEP 1
    ' PSET (trix, triy), tricc
    'NEXT trix
   NEXT triy
  END IF

 END IF
NEXT triv

'LINE (0, 0)-(639, 349), 10, BF
LOCATE 11, 1: PRINT triax; triay; triaz;
LOCATE 12, 1: PRINT triax; triay; triaz;
LOCATE 13, 1: PRINT triax; triay; triaz;
   
'LINE (319 + size * triax, 174 + size * triay)-(319 + size * tribx, 174 + size * triby), tricc
'LINE (319 + size * tribx, 174 + size * triby)-(319 + size * tricx, 174 + size * tricy), tricc
'LINE (319 + size * tricx, 174 + size * tricy)-(319 + size * triax, 174 + size * triay), tricc

END SUB

